#vymazn pedchozch hodnot
restart;

#nastaven parametr soustavy
m := 5;
k := 300;
k3 := 200;
b := 6;

#nastaven simulovanch hodnot
F := 100;
omega_min := 0.1;
omega_max := 16.0;
krok_omega := 0.1;
x_poc := 0;
v_poc := 0;

#definice pohybov rovnice systmu
rce_syst := diff(diff(x(t),t),t) = -1/m*(b*diff(x(t),t)+k*x(t)+k3*x(t)^3-F*sin(omega*t));

#nastaven parametr simulace
tolerance_x := 0.005:
tolerance_v := 0.00001:
max_t_sim := 2000:

#inicializace vektor ustlen vchylky a frekvence budc sly
pocet := trunc((omega_max-omega_min)/krok_omega+1):
AMPLITUDA := Vector(1..pocet):
OMEGA := Vector(1..pocet):


for i4 from 1 to pocet do

	#vpoet omega pro ppad prchodu od nich frekvenc smrem k vym
	omega := omega_min-krok_omega+i4*krok_omega:
	#vpoet omega pro ppad prchodu smrem od vych k nim
	#omega := omega_max+krok_omega-i4*krok_omega:

	#een diferenciln rovnice pro pedem neuren asov sek (maxfun=0)
	reseni := dsolve([rce_syst,x(0) = x_poc,D(x)(0) = v_poc],numeric,maxfun=0):

	#cyklus pro vyeten kmit
	#nastaven asu simulace na potek
	t_sim := 0:
	#vytvoen vektoru extrm a nastaven indexovn
	EXTREM := Vector(1..10):
	i := 1:
	#nastaven pznaku opakovn
	mimo_toleranci := 1:
	while mimo_toleranci = 1 do 
		#definovn zkladnho kroku jako cca 0.1 nsobek periody kmitu
		krok := 0.6/omega:
		#definovn pznaku nalezen
		nalezeno :=0:

		#hledn kladn plvlny
		t_sim := t_sim+krok:
		rychlost := op(2,reseni(t_sim)[3]):
		while rychlost < 0 do
			t_sim := t_sim+krok:
			rychlost := op(2,reseni(t_sim)[3])
		end do:

		#hledn konce kladn plvlny pomoc postupnho dlen kroku
		while nalezeno < 1 do
			while rychlost > 0 do
				t_sim := t_sim+krok:
				rychlost := op(2,reseni(t_sim)[3]):
			end do:
			#konec peskoen, nvrat o krok zpt
			t_sim := t_sim-krok:
			rychlost := op(2,reseni(t_sim)[3]):
			#kontrola zda je ji rychlost v toleranci, nastaven pznaku
			if rychlost < tolerance_v then
				nalezeno := 1:
			end if:
			krok := krok/10:
		end do:

		#uloen nalezenho extrmu
		EXTREM[i] := op(2,reseni(t_sim)[2]):
		i := i+1:
		#kontrola pekroen dlky vektoru
		if i > 10 then
			i := i-10:
		end if:
		
		#vpoet prmrn hodnoty vchylky
		prumer := 0:
		for i2 from 1 to 10 do
			prumer := prumer+EXTREM[i2]:
		end do:
		prumer := prumer/10:
		
		#kontrola zda jsou kmity v toleranci
		mimo_toleranci :=0:
		for i3 from 1 to 10 do
			if abs(EXTREM[i3]-prumer) > prumer*tolerance_x then
				mimo_toleranci := 1:
			end if:
		end do:

		#kontrola zda byl pekroen maximln as
		mc := max_t_sim-trunc(t_sim):
		if mc < 1 then
			mimo_toleranci := 0:
		end if:
	end do:
	
	#uloen nalezench hodnot do pslunch vektor
	AMPLITUDA[i4] := prumer:
	OMEGA[i4] := omega:	

	#nalezen potench podmnek
	krok := 0.6/omega:
	while abs(evalf(sin(omega*t_sim))) > tolerance_v do
		if evalf(sin(omega*t_sim)) > 0 then
			t_sim := t_sim-krok:
			if evalf(sin(omega*t_sim)) < 0 then
				t_sim := t_sim+krok:
				krok := krok/2:
			end if:
		else
			t_sim := t_sim-krok:
		end if:
	end do:
	x_poc := op(2,reseni(t_sim)[2]):
	v_poc := op(2,reseni(t_sim)[3]):

end do:
plot(OMEGA,AMPLITUDA,title='Amplitudo-frekvenn charakteristika',labels=['omega [rad/s]','A [m]']);