clc                 %mazn
clear

m = 5;              %nastaven parametr soustavy
k = 300;
k3 = 200;
b = 6;

F = 100;            %nastaven simulovanch hodnot
omega_min = 0.1;
omega_max = 16;
krok_omega = 0.1;
poc_vychylka = 0;
poc_rychlost = 0;

doba_sim = 500;     %nastaven parametr simulace
max_t_sim = 2000;
tolerance = 0.005;

for i4 = 1:1:(omega_max-omega_min)/krok_omega+1
    omega = omega_min-krok_omega+i4*krok_omega      %vpoet omega pro ppad prchodu od nich frekvenc smrem k vym
	%omega = omega_max+krok_omega-i4*krok_omega     %vpoet omega pro ppad prchodu smrem od vych k nim
    
    y0 = [poc_vychylka; poc_rychlost];      %nastaven potench podmnek
    tspan = [0, doba_sim];                  %nastaven doby simulace
    options = '';                           %nastaven parametr numerick metody
    mimo_toleranci = 1;
   
    while mimo_toleranci == 1 && tspan(2) <= max_t_sim     %cyklus, dokud jsou kmity mimo toleranci, zvyuje se doba simulace, z dvodu ustlen vchylky;

        [T,Y] = ode45('dif_rce_oscil',tspan,y0,options,k,k3,m,b,F,omega);     %een diferenciln rovnice

        vychylka = 0;               %vyprzdnn vektor proto aby nov nebyly krat ne pro pedchoz omegu
        rychlost = 0;
        for i = 1:1:length(Y)       %naplnn vektor k vyeten vsledky simulace
            vychylka(i) = Y(i,1);
            rychlost(i) = Y(i,2);
        end
        
        extrem = [0 0 0 0 0 0 0 0 0 0];
        i = length(vychylka)-10;     %nastaven indexovn na potek, -10 z dvodu interpolace, protoe tam 10 pibyde
        i2 = 1;
        while i >= 10 && i2 <= 10
            if rychlost(i) < abs(rychlost(i)) && rychlost(i-1) == abs(rychlost(i-1))
                    for i3 = 1:1:20                            %naplnn vyetovanch promnnch 10 hodnotami okolo extrmu
                        x_interp(i3) = vychylka(i-11+i3);
                        v_interp(i3) = rychlost(i-11+i3);
                    end
                    extrem(i2) = interp1(v_interp,x_interp,0,'pchip');    %nalezen extrmu pomoc interpolace
                    i2 = i2+1;      %posun indexovn vektoru extrm
            end
            i = i-1;                %posun indexovn vyetovanch vektor
        end

        prumerna_vychylka = 0;                                    %vpoet prmrn hodnoty vchylky
        for i = 1:1:10
            prumerna_vychylka = prumerna_vychylka+extrem(i);
        end
        prumerna_vychylka = prumerna_vychylka/10;

        mimo_toleranci = 0;                                      %kontrola, zda jsou kmity v toleranci
        for i = 1:1:10
            if extrem(i) > prumerna_vychylka+prumerna_vychylka*tolerance || extrem(i) < prumerna_vychylka-prumerna_vychylka*tolerance
                mimo_toleranci = 1;
            end
        end
    
        tspan(2)= tspan(2)*2;
    end

    AMPLITUDA(i4) = prumerna_vychylka;
    OMEGA(i4) = omega;
    
    i = length(vychylka);     %nastaven indexovn na potek
    opak = 1;                 %nastaven na 1 proto, aby cyklus while probhl minimln 1x
    while i > 1 && opak == 1
        if sin(omega*T(i)) == abs(sin(omega*T(i))) && sin(omega*T(i-1)) < abs(sin(omega*T(i-1)))
            sin_interp = [sin(omega*T(i-1)),sin(omega*T(i))];   %pprava vektor pro interpolaci
            x_interp = [vychylka(i-1),vychylka(i)];
            v_interp = [rychlost(i-1),rychlost(i)];    
            poc_vychylka = interp1(sin_interp,x_interp,0);  %nalezen hodnot pomoc interpolace
            poc_rychlost = interp1(sin_interp,v_interp,0);
            opak = 0;           %ji nalezeno, dle neopakuj
        end
        i=i-1;                  %posun indexovn
    end
    
end

plot(OMEGA,AMPLITUDA);          %tisk amplitudofrekvenn charakteristiky
title('Amplitudo-frekvenn charakteristika');
xlabel('\omega [rad/s]');
ylabel('A [m]');